# This file was automatically generated by SWIG (http://www.swig.org).
# Version 2.0.2
#
# Do not make changes to this file unless you know what you are doing--modify
# the SWIG interface file instead.
# This file is compatible with both classic and new-style classes.

from sys import version_info
if version_info >= (2,6,0):
    def swig_import_helper():
        from os.path import dirname
        import imp
        fp = None
        try:
            fp, pathname, description = imp.find_module('_trimesh', [dirname(__file__)])
        except ImportError:
            import _trimesh
            return _trimesh
        if fp is not None:
            try:
                _mod = imp.load_module('_trimesh', fp, pathname, description)
            finally:
                fp.close()
            return _mod
    _trimesh = swig_import_helper()
    del swig_import_helper
else:
    import _trimesh
del version_info
try:
    _swig_property = property
except NameError:
    pass # Python < 2.2 doesn't have 'property'.
def _swig_setattr_nondynamic(self,class_type,name,value,static=1):
    if (name == "thisown"): return self.this.own(value)
    if (name == "this"):
        if type(value).__name__ == 'SwigPyObject':
            self.__dict__[name] = value
            return
    method = class_type.__swig_setmethods__.get(name,None)
    if method: return method(self,value)
    if (not static) or hasattr(self,name):
        self.__dict__[name] = value
    else:
        raise AttributeError("You cannot add attributes to %s" % self)

def _swig_setattr(self,class_type,name,value):
    return _swig_setattr_nondynamic(self,class_type,name,value,0)

def _swig_getattr(self,class_type,name):
    if (name == "thisown"): return self.this.own()
    method = class_type.__swig_getmethods__.get(name,None)
    if method: return method(self)
    raise AttributeError(name)

def _swig_repr(self):
    try: strthis = "proxy of " + self.this.__repr__()
    except: strthis = ""
    return "<%s.%s; %s >" % (self.__class__.__module__, self.__class__.__name__, strthis,)

try:
    _object = object
    _newclass = 1
except AttributeError:
    class _object : pass
    _newclass = 0


try:
    import weakref
    weakref_proxy = weakref.proxy
except:
    weakref_proxy = lambda x: x


class PSLGEditor(_object):
    """Proxy of C++ tritetmesh::PSLGEditor class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, PSLGEditor, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, PSLGEditor, name)
    __repr__ = _swig_repr
    __swig_destroy__ = _trimesh.delete_PSLGEditor
    __del__ = lambda self : None;
    def __init__(self): 
        """
        __init__(self) -> PSLGEditor

        Destructor. 
        """
        this = _trimesh.new_PSLGEditor()
        try: self.this.append(this)
        except: self.this = this
    def clear(self):
        """
        clear(self)

        Clear the registered PSLG data. 
        """
        return _trimesh.PSLGEditor_clear(self)

    def print_vertices(self):
        """
        print_vertices(self)

        Print all vertices. 
        """
        return _trimesh.PSLGEditor_print_vertices(self)

    def register_vertices(self, *args):
        """
        register_vertices(self, x_coord, y_coord)
        register_vertices(self, x_coord, y_coord, attributes)
        register_vertices(self, x_coord, y_coord, attributes1, attributes2)
        register_vertices(self, x_coord, y_coord, attributes1, attributes2, attributes3)

        Register vertices by their coordinates.

        Add vertices to the PSLG by giving the coordinates in two different
        array(vector) parameters.

        The coordinates have to be the same size.

        Optionally several sequences (max 3) can be provided, with attributes
        that are assigned each vertex. These values are then interpolated in
        the new mesh.

        Parameters:
        -----------

        x_coord:  A sequence with the x coordinates

        y_coord:  A sequence with the y coordinates

        attributesX:  Optional sequences of attributes that are assigned each
        vertex 
        """
        return _trimesh.PSLGEditor_register_vertices(self, *args)

    def add_vertex_marker(self, *args):
        """
        add_vertex_marker(self, marker, vertices)

        Add a marker to the supplied vector of vertices.

        Parameters:
        -----------

        marker:  The attribute (integer)

        vertices:  A sequence with the vertices 
        """
        return _trimesh.PSLGEditor_add_vertex_marker(self, *args)

    def add_vertex_attributes(self, *args):
        """
        add_vertex_attributes(self, attributes)

        Add attributes to the correspondning vertices.

        The sequence provided should be the same length as the number of
        registered vertices. Any number of vertex attributes can be provided
        for each vertex. Call this function several times to facilitate this.

        Parameters:
        -----------

        attributes:  The attributes given as a sequence (float) 
        """
        return _trimesh.PSLGEditor_add_vertex_attributes(self, *args)

    def add_polygon(self, *args):
        """
        add_polygon(self, polygon, attribute = 0, max_area = -1.0)
        add_polygon(self, polygon, attribute = 0)
        add_polygon(self, polygon)

        Add a polygon to the PSLG.

        The polygon is given by a sequence of vetex number. The polygon should
        be closed or closeable, i.e., not a straight line.

        Optionally a marker and a maximum area for the triangles in the
        polygon can be provided. This option is only available for simple
        polygons, where the mean of the coordinates is within the border of
        the polygon, and no other polygons is included inside it. If this is
        not the case, set the region manually using add_region().

        Parameters:
        -----------

        polygon:  A sequence of vertex numbers defining the closed polygon

        attribute:  A float that is inherited by triangles in this polygon

        max_area:  A positive float that sets an upper bound on the area of
        each triangle in the polygon 
        """
        return _trimesh.PSLGEditor_add_polygon(self, *args)

    def add_polygon_hole(self, *args):
        """
        add_polygon_hole(self, polygon)

        Add a polygon to the PSLG and make a hole out of it.

        The polygon is given by a sequence of vetex number. The polygon should
        be closed or closeable, i.e., not a straight line.

        The polygon need to be simpel, where the mean of the coordinates is
        within the border of the polygon. If a more complex polygonal hole is
        neaded, set the hole manually using add_hole().

        Parameters:
        -----------

        polygon:  A sequence of vertex numbers defining the closed polygon 
        """
        return _trimesh.PSLGEditor_add_polygon_hole(self, *args)

    def add_segments(self, *args):
        """
        add_segments(self, segments, marker = 0)
        add_segments(self, segments)

        Add a seqence of segments.

        The segments is provided by a sequence of vertex numbers Optionally a
        marker can be provided that is inherited by the any sub-segments

        If the sequence include segments that is allready registered, e.g., by
        another function, they are not added, but if a marker is provided this
        is registered.

        Parameters:
        -----------

        sequence:  A sequence of vertex numbers defining the segments

        marker:  An integer defining the marker that will be inherited by any
        sub- segments 
        """
        return _trimesh.PSLGEditor_add_segments(self, *args)

    def add_hole(self, *args):
        """
        add_hole(self, point)

        Add a hole to the PSLG.

        The hole is provided as a point situated inside a closed path of
        segments, previuosly provded either by add_segments() or
        add_polygon(). Make sure that the point is sourrounded by a closed
        path of segments. The mesh can otherwise dissapear!

        Parameters:
        -----------

        point:  A sequence of length 2, containing the coordinates of the
        point 
        """
        return _trimesh.PSLGEditor_add_hole(self, *args)

    def add_region(self, *args):
        """
        add_region(self, point, attribute, max_area = -1.0)
        add_region(self, point, attribute)

        Add a region to the PSLG.

        The region is provided as a point situated inside a closed path of
        segents, previuosly provded either by add_segments() or add_polygon(),
        together with an attribute. All triangles produced inside the region
        will inherit the attribute.

        Optionally a maximal are can be provided limiting the volume of the
        tetrahedrons inside the region.

        Parameters:
        -----------

        point:  A sequence of length 2, containing the coordinates of the
        point

        attribute:  A float defining the attribute of the tetrahedrons inside
        the region

        max_volume:  A float definging the maximal volume of the tetrahedrons
        inside the region 
        """
        return _trimesh.PSLGEditor_add_region(self, *args)

    def build(self, *args):
        """
        build(self, file_name, save_triangle = False)
        build(self, file_name)

        Build the PSLG.

        Use the registered information to build a mesh. Save the result with
        the provided file name 
        """
        return _trimesh.PSLGEditor_build(self, *args)

    def print_triangle_parameters(self):
        """
        print_triangle_parameters(self)

        Print the present triangle parameters. 
        """
        return _trimesh.PSLGEditor_print_triangle_parameters(self)

    def set_minimum_angle(self, *args):
        """
        set_minimum_angle(self, angle)

        Set a minimum angle of a generated triangle. (triangle -qX option). 
        """
        return _trimesh.PSLGEditor_set_minimum_angle(self, *args)

    def set_uniform_area_constraint(self, *args):
        """
        set_uniform_area_constraint(self, constraint)

        Set uniform volume constraint (triangle -aX.X option). 
        """
        return _trimesh.PSLGEditor_set_uniform_area_constraint(self, *args)

    def add_area_function(self, *args):
        """
        add_area_function(self, area_func)

        Set a user defined area function. 
        """
        return _trimesh.PSLGEditor_add_area_function(self, *args)

    def set_verbosity(self, *args):
        """
        set_verbosity(self, verbosity)

        Set verbosity (triangle -V option). 
        """
        return _trimesh.PSLGEditor_set_verbosity(self, *args)

    def set_generate_edge_information(self, *args):
        """
        set_generate_edge_information(self, generate)

        set generate edge indformation (triangle -e option) 
        """
        return _trimesh.PSLGEditor_set_generate_edge_information(self, *args)

    def set_enclose_convex_hull(self, *args):
        """
        set_enclose_convex_hull(self, enclose)

        Enclose a convex hull (triangle -c option). 
        """
        return _trimesh.PSLGEditor_set_enclose_convex_hull(self, *args)

    def save_pslg(self, *args):
        """save_pslg(self, file_name)"""
        return _trimesh.PSLGEditor_save_pslg(self, *args)

PSLGEditor_swigregister = _trimesh.PSLGEditor_swigregister
PSLGEditor_swigregister(PSLGEditor)

class AreaFunction(_object):
    """Proxy of C++ tritetmesh::AreaFunction class"""
    __swig_setmethods__ = {}
    __setattr__ = lambda self, name, value: _swig_setattr(self, AreaFunction, name, value)
    __swig_getmethods__ = {}
    __getattr__ = lambda self, name: _swig_getattr(self, AreaFunction, name)
    __repr__ = _swig_repr
    def __init__(self): 
        """__init__(self) -> AreaFunction"""
        if self.__class__ == AreaFunction:
            _self = None
        else:
            _self = self
        this = _trimesh.new_AreaFunction(_self, )
        try: self.this.append(this)
        except: self.this = this
    __swig_destroy__ = _trimesh.delete_AreaFunction
    __del__ = lambda self : None;
    def eval(self, *args):
        """eval(self, x, y) -> double"""
        return _trimesh.AreaFunction_eval(self, *args)

    def __disown__(self):
        self.this.disown()
        _trimesh.disown_AreaFunction(self)
        return weakref_proxy(self)
AreaFunction_swigregister = _trimesh.AreaFunction_swigregister
AreaFunction_swigregister(AreaFunction)


def triunsuitable(*args):
  """triunsuitable(triorg, tridest, triapex, area) -> int"""
  return _trimesh.triunsuitable(*args)

cvar = _trimesh.cvar

